<id>
Must View Topic for YaBB 2.6.0
</id>

<version>
0.1.3
</version>

<mod info>
Description
-----------
This Mod will allow you to force users to view a specified topic before any other topics can be viewed. (Whether or not the member has viewed the topic is saved in a cookie.)

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Go into Admin Center => Forum Settings => Members tab => Must View Topic to configure the settings.

Files to edit
-------------
Admin/ModList.pm
Admin/NewSettings.pm
Admin/Settings_Main.pm
Languages/English/Admin.lng
Languages/English/Display.lng
Languages/English/Post.lng
Sources/Display.pm
Sources/ModifyMessage.pm
Sources/Post.pm
Sources/System.pm
Templates/default/Post.template

Version History
---------------
0.1 - First Release - 12th February 2013
0.1.1 - Fixed issue with username value being stored if field was empty - 13th February 2013
0.1.2 - Small change to make mod compatible with Guest Topic View Limit mod - 25th February 2013
0.1.3 - Updated to YaBB 2.6.0 by Dandello
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $must_view_topic_mod = "Must View Topic|Derek Barnstorm, updated for 2.6.0 by Dandello|This Mod will allow you to force users to view a specified topic before any other topics can be viewed.|0.1.3|2nd July, 2014";
    push (@installed_mods, "$must_view_topic_mod");

</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
\$ML_Allowed = $ML_Allowed;                 # allow browse MemberList
</search for>

<add after>

########## Must View Topic configuration ##########

\$mustViewEnabled = $mustViewEnabled;       # Set to 1 to enable Must View Topic
\$mustViewID = "\Q$mustViewID\E";           # Set the thread ID of topic which users must view
\$mustViewGroups = "\Q$mustViewGroups\E";   # Member groups which must view the topic, '' == all members
\$mustViewGuests = $mustViewGuests;         # Force guests to view the topic
\$mustViewBoards = "\Q$mustViewBoards\E";   # Boards which won't be viewable until the topic has been viewed, '' == all boards
\$mustViewInfo = "\Q$mustViewInfo\E";       # Additional information for the Must View Topic notice
</add after>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
require Admin::ManageBoards; # needed for avatar upload settings
</search for>

<add after>

require "$boardsdir/forum.master";
foreach $catid (@categoryorder) {
    @bdlist = split /,/xsm, $cat{$catid};
    ($catname, undef, undef, undef) = split /[|]/xsm, $catinfo{"$catid"};
    ToChars($catname);
    $boardList .= qq~<option disabled="disabled">$catname</option>\n~;
    foreach my $board (@bdlist) {
        ($boardname, undef, undef) = split /[|]/xsm, $board{"$board"};
        ToChars($boardname);
        $sel_board = q{};
        foreach (split /\, /sm, $mustViewBoards) {
            if ($_ eq $board) { $sel_board = q~ selected="selected"~; }
        }
        $boardList .= qq~<option value="$board"$sel_board>&nbsp;&nbsp;$boardname</option>\n~;
    }
}

my ( $mustViewTopic, $mustViewUser ) = split /\~/xsm, $mustViewID;
$mustViewID = $mustViewTopic;
$mustViewInfo   =~ s/<br \/>/\n/gsm;
</add after>

<search for>
            name => 'group_stars_ml',
            validate => 'boolean',
        },
</search for>

<add after>
        {
            header => $settings_txt{'must_view_topic'},
        },
        {
            description => qq~<label for="must_view_enabled">$admin_txt{'must_view_enabled'}</label>~,
            input_html => qq~<input type="checkbox" name="mustViewEnabled" id="must_view_enabled" value="1"${ischecked($mustViewEnabled)} />~,
            name => 'mustViewEnabled',
            validate => 'boolean',
        },
        {
            description => qq~<label for="must_view_id">$admin_txt{'must_view_id'}</label>~,
            input_html => qq~<input type="text" size="10" name="mustViewID" id="must_view_id" value="$mustViewID" />~,
            name => 'mustViewID',
            validate => 'text,null',
            depends_on => ['mustViewEnabled'],
        },
        {
            description => qq~<label for="must_view_groups">$admin_txt{'must_view_groups'}</label>~,
            input_html => qq~<select multiple="multiple" name="mustViewGroups" id="must_view_groups" size="8">~ . &DrawPerms($mustViewGroups, 0) . qq~</select>~,
            name => 'mustViewGroups',
            validate => 'text,null',
            depends_on => ['mustViewEnabled'],
        },
        {
            description => qq~<label for="must_view_guests">$admin_txt{'must_view_guests'}</label>~,
            input_html => qq~<input type="checkbox" name="mustViewGuests" id="must_view_guests" value="1"${ischecked($mustViewGuests)} />~,
            name => 'mustViewGuests',
            validate => 'boolean',
            depends_on => ['mustViewEnabled'],
        },
        {
            description => qq~<label for="must_view_boards">$admin_txt{'must_view_boards'}</label>~,
            input_html => qq~<select multiple="multiple" name="mustViewBoards" id="must_view_boards" size="8">$boardList</select>~,
            name => 'mustViewBoards',
            validate => 'text,null',
            depends_on => ['mustViewEnabled'],
        },
        {
            description => qq~<label for="must_view_info">$admin_txt{'must_view_info'}</label>~,
            input_html => qq~<textarea name="mustViewInfo" id="must_view_info" cols="35" rows="5">$mustViewInfo</textarea>~,
            name => 'mustViewInfo',
            validate => 'fulltext,null',
            depends_on => ['mustViewEnabled'],
        },
</add after>

<search for>
    ToHTML($settings{'mbname'});
</search for>

<add after>

    if ( $settings{'mustViewID'} ne q{} ) {
        if ( $settings{'mustViewID'} != $mustViewID ) {
            $settings{'mustViewID'} .= q{~} . $username;
        }
        else {
            $settings{'mustViewID'} .= q{~} . $mustViewUser;
        }
    }
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'must_view_enabled' => 'Enable Must View Topic?<br /><span class="small">This setting will allow you to force users to view a specified topic before any others topics can be viewed.</span>',
'must_view_id' => 'Enter the thread ID here of the topic which users must view:<br /><span class="small">This is the last part of the topic URL. e.g. 1278201900<br />Note that you can also set this option at the time of posting a Global Announcement.</span>',
'must_view_groups' => 'Specify the Member Groups which must view the topic:<br /><span class ="small">If no Member Groups are selected, all Member Groups are enabled.<br />Use Ctrl, Shift or Apple Key to select/deselect multiple groups.</span>',
'must_view_guests' => 'Force guests to view the topic?',
'must_view_boards' => 'Select the Boards which won\'t be viewable until the topic has been viewed:<br /><span class="small">If no boards are selected then no boards will be viewable.<br />Use Ctrl, Shift or Apple Key to select/deselect boards.</span>',
'must_view_info' => 'Add additional information to the Must View Topic notice:<br /><span class="small">HTML is allowed.</span>',
</add before>

<search for>
'images' => 'Images',
</search for>

<add after>
'must_view_topic' => 'Must View Topic',
</add after>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
);

1;
</search for>

<add before>
'must_view_title' => 'Important Message: Please Read',
'must_view_nav' => 'Important Message',
'must_view_admin' => 'The Forum Administrator',
'must_view_mod' => 'The Forum Moderator',
'must_view_info' => 'wishes you to view an important topic before proceeding.',
'must_view_button' => 'Click here to view topic',
'must_view_footer_1' => 'Thank you,',
'must_view_footer_2' => "The $mbname Team",
</add before>

<edit file>
Languages/English/Post.lng
</edit file>

<search for>
);

%npf_txt=(
</search for>

<add before>
'must_view_set' => 'Must view topic',
'must_view_desc' => 'Check this to block users from viewing any other topics until this topic has been viewed.',
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
    if ( AccessCheck( $currentboard, q{}, $boardperms ) ne 'granted' ) {
        fatal_error('no_access');
    }
</search for>

<add after>

    if ( $mustViewEnabled && $mustViewID ) {
        my ( $mustViewTopic, $mustViewUser ) = split /\~/xsm, $mustViewID;
        if ( $username ne $mustViewUser ) {
            if ( $FORM{'mustview'} == $mustViewTopic ) {
                if ( $iamguest ) {
                    $yySetCookies2 = write_cookie(
                        -name    => 'mustviewtopic',
                        -value   => $mustViewTopic,
                        -expires => 'Sunday, 17-Jan-2038 00:00:00 GMT');
                }
                else {
                     ${$uid.$username}{'mustviewtopic'} = $mustViewTopic;
                     UserAccount($username, 'update');
                }
            }
            if ( $mustViewGroups ) {
                $allowGroups = 0;
                foreach my $selectGroup ( split /, /sm, $mustViewGroups ) {
                    if ( ( $selectGroup eq ${$uid.$username}{'position'} ) || ( $selectGroup eq $memberunfo{$username} ) ) { $allowGroups = 1; last; }
                    foreach ( split ( /,/, ${$uid.$username}{'addgroups'} ) ) {
                        if ( $selectGroup eq $_ ) { $allowGroups = 1; last; }
                    }
                }
            }
            else {
                $allowGroups = 1;
            }
            if ( $mustViewBoards ) {
                $mustViewBoard = 0;
                foreach ( split /\, /sm, $mustViewBoards ) {
                    if ( $_ eq $currentboard ) { $mustViewBoard = 1; }
                }
            }
            else {
                $mustViewBoard = 1;
            }
            if ( $mustViewGuests ) {
                my $iambot = 0;
                my $user_host = (gethostbyaddr(pack('C4', split /\./xsm, $user_ip), 2))[0];
                if ( -e "$vardir/bots.hosts" ) {
                    fopen(BOTS, "$vardir/bots.hosts") || fatal_error('cannot_open',"$vardir/bots.hosts", 1);
                    my @botlist = <BOTS>;
                    fclose (BOTS);
                    chomp(@botlist);
                    foreach (@botlist) {
                        $_ =~ /(.*?)\|(.*)/;
                        $bot_name = $1;
                        $bothost = qq~$user_host#$ENV{'HTTP_USER_AGENT'}~;
                        if ( $user_host =~ /$bot_name/ism ) { $iambot = 1; }
                    }
                }
            }
            if ( !$FORM{'mustview'} && $mustViewBoard ) {
                if ( ( $iamguest && !$iambot && $mustViewGuests && $yyCookies{'mustviewtopic'} != $mustViewTopic ) || ( !$iamguest && $allowGroups && ${$uid.$username}{'mustviewtopic'} != $mustViewTopic ) ) {
                    $yytitle = $display_txt{'must_view_title'};
                    $yynavigation = qq~&rsaquo; $display_txt{'must_view_nav'}~;
                    if ( $mustViewInfo ) { $mustViewInfo = qq~<p>$mustViewInfo</p>~; }
                    LoadUser($mustViewUser);
                    my $mustViewUserTxt;
                    if    ( ${$uid.$mustViewUser}{'position'} eq 'Administrator' ) { $mustViewUserTxt = $display_txt{'must_view_admin'}; }
                    elsif ( ${$uid.$mustViewUser}{'position'} eq 'Global Moderator' ) { $mustViewUserTxt = $display_txt{'must_view_mod'}; }
                    $yymain = qq~
<table class="tabtitle">
    <th>
        <td>$micon{'urgent'} $display_txt{'must_view_title'}</td>
    </th>
</table>
<table>
    <tr>
        <td class="windowbg" style="padding: 0 2em">
            <p style="margin-top: 0.3em;">$mustViewUserTxt $display_txt{'must_view_info'}</p>
            $mustViewInfo
            <p>
          <form action="$scripturl?num=$mustViewTopic" method="post">
            <input type="submit" value="$display_txt{'must_view_button'}" class="button" />
            <input type="hidden" name="mustview" value="$mustViewTopic" />
          </form>
        </p>
        <p>
          $display_txt{'must_view_footer_1'}<br /><br />
          ${$uid.$mustViewUser}{'realname'},<br /><br />
          $display_txt{'must_view_footer_2'}
        </p>
    </td>
  </tr>
</table>~;
    template();
    exit;
                }
            }
        }
    }
</add after>

<edit file>
Sources/ModifyMessage.pm
</edit file>

<search for>
        fclose(BOARD);
        BoardSetLastInfo( $currentboard, \@board );
    }
</search for>

<add after>

    if ( $mustViewEnabled ) {
        if ( $iamgmod ) { require "$vardir/gmodsettings.txt"; }
        if ( $currentboard eq $annboard && $FORM{'must_view_set'} && ( $iamadmin || $iamgmod && $gmod_access{'newsettings;page=main'} eq 'on' ) ) {
            my ( $mustViewTopic, undef ) = split /\~/xsm, $mustViewID;
            if ( $threadid != $mustViewTopic ) {
                $mustViewID = $threadid . '~' . $username;
                require Admin::NewSettings;
                SaveSettingsTo('Settings.pm');
            }
        }
    }
</add after>

<edit file>
Sources/Post.pm
</edit file>

<search for>
require Sources::SpamCheck;
</search for>

<add after>
if ( $mustViewEnabled && $iamgmod ) { require "$vardir/gmodsettings.txt"; }
</add after>

<search for>
    if ( $pollthread == 2 ) { $settofield = 'question'; }
</search for>

<add after>

    my ( $mustViewSet, $mustViewChecked );
    if ( $mustViewEnabled && $currentboard eq $annboard && ( $iamadmin || $iamgmod && $gmod_access{'newsettings;page=main'} eq 'on' ) ) {
        my ( $mustViewTopic, undef ) = split /\~/xsm, $mustViewID;
        if ( $mustViewTopic ne q{} && $threadid == $mustViewTopic || $FORM{'must_view_set'} ) { $mustViewChecked = q~ checked="checked"~; }
        $mustViewSet = qq~
    <tr id="feature_status_9" class="windowbg">
        <td><label for="must_view_set"><b>$post_txt{'must_view_set'}:</b></label></td>
        <td><input type="checkbox" name="must_view_set" id="must_view_set" value="1"$mustViewChecked /> <span class="small"><label for="must_view_set">$post_txt{'must_view_desc'}</label></span></td>
    </tr>~;
    }
</add after>

<search for>
        $my_postsection =~ s/{yabb notification}/$notification/sm;
        $my_postsection =~ s/{yabb favoriteadd}/$favoriteadd/sm;
</search for>

<add before>
        $my_postsection =~ s/{yabb mustViewSet}/$mustViewSet/sm;
</add before>

<search for>
    if ( !$iamguest ) { Recent_Write( 'incr', $thread, $username, $date ); }
</search for>

<add after>

    if ( $mustViewEnabled && $currentboard eq $annboard && $FORM{'must_view_set'} && ( $iamadmin || $iamgmod && $gmod_access{'newsettings;page=main'} eq 'on' ) ) {
        my ( $mustViewTopic, undef ) = split /\~/xsm, $mustViewID;
        if ( $thread != $mustViewTopic ) {
            $mustViewID = $thread . '~' . $username;
            require Admin::NewSettings;
            SaveSettingsTo('Settings.pm');
        }
    }
</add after>

<edit file>
Sources/System.pm
</edit file>

<search for>
    if ($extendedprofiles) {
        require Sources::ExtendedProfiles;
</search for>

<add before>
    push(@tags, 'mustviewtopic');
</add before>

<edit file>
Templates/default/Post.template
</edit file>

<search for>
        <td class="windowbg2 vtop">{yabb my_googie}{yabb mypost_smilie_array}{yabb my_post_feata}{yabb my_post_smilies}{yabb my_feat5}{yabb my_is_prev}{yabb notification}{yabb favoriteadd}
</search for>

<replace>
        <td class="windowbg2 vtop">{yabb my_googie}{yabb mypost_smilie_array}{yabb my_post_feata}{yabb my_post_smilies}{yabb my_feat5}{yabb my_is_prev}{yabb mustViewSet}{yabb notification}{yabb favoriteadd}
</replace>

